#if !defined(__BGC_H__)
#define      __BGC_H__

#include "globals.h"
#include "utils/graphIO.h"

#ifdef __XGRAPH_COUNT_OPERATIONS__
#include "utils/stats.h"
#endif

#include "representations/tradArrayNoDegGraphR.h"
#include "representations/tradArrayLocalityAwareNoDegGraphR.h"

using namespace std;

class BGC {
 public:
    void setOpenmpConfig(int dynamic, int threads);
    void runPushWithOpenMP(TradArrayLocalityAwareNoDegGraphR* G_csr, int maxiter, int limit, int** bgc_out);
    void runPullWithOpenMP(TradArrayLocalityAwareNoDegGraphR* G_csr, int maxiter, int limit, int** bgc_out);
    void graphColoringGreedySwitch(TradArrayNoDegGraphR* G_csr, int switch_iter, int** sp);
    void graphColoringSwitch(TradArrayNoDegGraphR* G_csr, int switch_iter, int** sp);
    void runGreedyColoring(TradArrayNoDegGraphR* G_csr, int** bgc_out);

void newGraphColoring(TradArrayNoDegGraphR* G_csr, int** sp);

//    void newGraphColoring(TradArrayNoDegGraphR* G_csr, int** sp);
    void setRunID(int run_id) {this->run_id = run_id;}

    int run_id;
#ifdef __XGRAPH_COUNT_OPERATIONS__
    int papi_set;
#endif
};

#endif
