#if !defined(__MST_H__)
#define      __MST_H__

#include <vector>
#include <array>
#include "tbb/tbb.h"

#include "globals.h"
#include "utils/graphIO.h"

#ifdef __XGRAPH_COUNT_OPERATIONS__
#include "utils/stats.h"
#endif

#include "representations/tradArrayNoDegGraphR.h"
#include "representations/tradArrayNoDegEWGraphR.h"
#include "representations/tradArrayLocalityAwareNoDegGraphR.h"

using namespace std;

class MST {
 public:
    void setOpenmpConfig(int dynamic, int threads);
    void runPushWithOpenMP(TradArrayNoDegEWGraphR* G_csr, int threads, int* path_weight);
    void runPullWithOpenMP(TradArrayNoDegEWGraphR* G_csr, int threads, int* path_weight);
//    void runPushWithOpenMP_bucket(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
//    void runPullWithOpenMP_bucket(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
//    void runSwitchedWithOpenMP(TradArrayNoDegEWGraphR* G_csr, int threads_n, int switch_iter_n, int max_edge, int* path_weight);
    void setRunID(int run_id) {this->run_id = run_id;}

    void runPullWithOpenMP___MST_bucket(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
    void runPushWithOpenMP___MST_bucket(TradArrayNoDegEWGraphR* G_csr, int* path_weight);

    void runPullWithOpenMP___MST_concurrency(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
    void runPushWithOpenMP___MST_concurrency(TradArrayNoDegEWGraphR* G_csr, int* path_weight);

    void runPullWithOpenMP___MST_old(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
    void runPushWithOpenMP___MST_old(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
    void runSwitchedWithOpenMP___MST_old(TradArrayNoDegEWGraphR* G_csr, int threads_n, int switch_iter_n, int max_edge, int* path_weight);

    void runPullWithOpenMP_bucket___MST_old(TradArrayNoDegEWGraphR* G_csr, int* path_weight);
    void runPushWithOpenMP_bucket___MST_old(TradArrayNoDegEWGraphR* G_csr, int* path_weight);

#ifdef __XGRAPH_COUNT_OPERATIONS__
  int papi_set;
#endif

    int run_id;
};

#endif
