#if !defined(__SSSP_H__)
#define      __SSSP_H__

#include "globals.h"
#include "utils/graphIO.h"

#ifdef __XGRAPH_COUNT_OPERATIONS__
#include "utils/stats.h"
#endif

#include "representations/tradArrayNoDegGraphR.h"
#include "representations/tradArrayNoDegEWGraphR.h"
#include "representations/tradArrayLocalityAwareNoDegGraphR.h"

using namespace std;

class SSSP {
  public:
    void setOpenmpConfig(int dynamic, int threads);
    void runPushWithOpenMP(TradArrayNoDegEWGraphR* G_csr, int start_vertex, int max, int** sp);
    void runPullWithOpenMP(TradArrayNoDegEWGraphR* G_csr, int start_vertex, int max, int** sp);
    void graphColoring(TradArrayNoDegGraphR* G_csr, int** sp, int maxiter);
    void setRunID(int run_id) {this->run_id = run_id;}

#ifdef __XGRAPH_COUNT_OPERATIONS__
    int papi_set;
#endif

    int run_id;
};

#endif
