#if !defined(__TC_H__)
#define      __TC_H__

#include "globals.h"

#ifdef __XGRAPH_DIST__
#include "fompi.h"
#include "representations/tradArrayDistGraphR.h"
#include "representations/tradArrayDistG500GraphR.h"
#endif

#ifdef __XGRAPH_COUNT_OPERATIONS__
#include "utils/stats.h"
#endif

#include "utils/graphIO.h"
#include "representations/tradArrayNoDegGraphR.h"

using namespace std;

class TC {
 public:
  void setOpenmpConfig(int dynamic, int threads);
  void runPushWithOpenMP(TradArrayNoDegGraphR* G_csr, int64_t** trianglecounting_out);
  void runPullWithOpenMP(TradArrayNoDegGraphR* G_csr, int64_t** trianglecounting_out);
  void setRunID(int run_id) {this->run_id = run_id;}

#ifdef __XGRAPH_DIST__
  void runPush_dist_MP_MPI(TradArrayDistGraphR* G, int64_t** tc_vals_out);
  void runPull_dist_MPIRMA(TradArrayDistGraphR* G_csr, int64_t** tc_out);
  void runPush_dist_RMA_MPI_plus_MPI_Atomics(TradArrayDistGraphR* G, int64_t** tc_vals_out);

  void runPull_dist_MPIRMA(TradArrayDistG500GraphR* G_csr, int64_t** tc_out);
  void runPush_dist_RMA_MPI_plus_MPI_Atomics(TradArrayDistG500GraphR* G, int64_t** tc_vals_out);
#endif

  int run_id;
#ifdef __XGRAPH_COUNT_OPERATIONS__
  int papi_set;
#endif
};

#endif
